scite_Command 'Sort lines (ascending)|sort_text'
scite_Command 'Sort lines (descending)|sort_text_reverse'

-- Sort a selected text

function lines(str)
  local t = {}
  for i = 0,editor.LineCount do
    table.insert(t,(editor:GetLine(i)))
  end
  return t
end

function real_sort_text(f)
  local sel = editor:GetSelText()
  if #sel == 0 then sel = editor:GetText() end
  local eol = string.match(sel, "\n$")
  local buf = lines(sel)
  --table.foreach(buf, print) --used for debugging
  table.sort(buf,f)
  local out = table.concat(buf, "\n")
  if eol then out = out.."\n" end
  editor:ReplaceSel(out)
end

function sort_text()
  real_sort_text(function(a, b) return a < b end)
end

function sort_text_reverse()
  real_sort_text(function(a, b) return a > b end)
end
